unit Unit1;
{
 XBitmap component exerciser
 components, events

 version 2.0
 2-2-2022
 replaced TColorbox by TDav7ColorPicker from Dav7Components
 corrected initialising Xcliprect of TXbitmaps
} 

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls,XBitmap, dav7components;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    mainbtn: TDavArrayBtn;
    Label1: TLabel;
    statictext4: TStaticText;
    Label2: TLabel;
    penwidthUD: TUpDown;
    statictext5: TStaticText;
    Label3: TLabel;
    penstyleUD: TUpDown;
    linebox: TPaintBox;
    statictext3: TStaticText;
    Label4: TLabel;
    Label5: TLabel;
    statictext6: TStaticText;
    brushlevelUD: TUpDown;
    Label6: TLabel;
    penlevelUD: TUpDown;
    Label7: TLabel;
    brushcheck: TCheckBox;
    statictext2: TStaticText;
    radiusUD: TUpDown;
    Label9: TLabel;
    brushbox: TPaintBox;
    fillbox: TPaintBox;
    Label10: TLabel;
    Label11: TLabel;
    arr1check: TCheckBox;
    arr2check: TCheckBox;
    StaticText1: TStaticText;
    Label8: TLabel;
    arrowstyleUD: TUpDown;
    stretchgroup: TRadioGroup;
    fillpatgroup: TRadioGroup;
    StaticText7: TStaticText;
    fillstyleUD: TUpDown;
    Label12: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    dav7ColorPicker1: Tdav7ColorPicker;
    dav7ColorPicker2: Tdav7ColorPicker;
    procedure FormPaint(Sender: TObject);
    procedure mainbtnBtnPaint(sender: TObject; BtnNr: Byte;
      status: TBtnStatus);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure lineboxPaint(Sender: TObject);
    procedure brushboxPaint(Sender: TObject);
    procedure fillboxPaint(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure penwidthUDClick(Sender: TObject; Button: TUDBtnType);
    procedure arrowstyleUDClick(Sender: TObject; Button: TUDBtnType);
    procedure arr1checkClick(Sender: TObject);
    procedure fillstyleUDClick(Sender: TObject; Button: TUDBtnType);
    procedure fillpatgroupClick(Sender: TObject);
    procedure penstyleUDClick(Sender: TObject; Button: TUDBtnType);
    procedure penlevelUDClick(Sender: TObject; Button: TUDBtnType);
    procedure brushlevelUDClick(Sender: TObject; Button: TUDBtnType);
    procedure radiusUDClick(Sender: TObject; Button: TUDBtnType);
    procedure stretchgroupClick(Sender: TObject);
    procedure brushcheckClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mainbtnBtnChange(sender: TObject; BtnNr: Byte;
      status: TBtnStatus; button: TMouseButton);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dav7ColorPicker1Select(sender: TObject; color: Integer);
    procedure dav7ColorPicker2Select(sender: TObject; color: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  var map1,map2 : TXbitmap;

implementation

{$R *.DFM}

uses controlunit;

procedure showlinestyle;forward;
procedure showfillstyle;forward;

var linemap,fillmap : TXbitmap;

//--- menu change --------

procedure TForm1.mainbtnBtnChange(sender: TObject; BtnNr: Byte;
  status: TBtnStatus; button: TMouseButton);
begin
 mainbutton := TMainbutton(BtnNr);
 case mainbutton of
  mbClear   : begin
               clipping := false;
               maprect := fullmaprect;
               clearmaps;
               mainbtn.btnRelease(byte(mainbutton));
               mainbutton := mbOff
              end;
  mbPolygon : begin
               startdraw;
               polygonProc;
              end; 
  mbline,
  mbEllipse,
  mbRect,
  mbArc      : begin
                startdraw;
               end;
  mbClip    : startclip;
  mbPicture : begin
               if assigned(bm) then
                begin
                 bm.free; bm := nil;
                end;
               pictureProc;
              end; 
 end;//case
end;

//--- mouse / key events

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if shift * [ssShift] = [] then begin
                                 x := ((x+5) div 10) * 10;
                                 y := ((y+5) div 10) * 10;
                                end;
 mouseX := x; mouseY := y;
 mouseEvent := meDown;
 mouseproc;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if shift * [ssShift] = [] then begin
                                 x := ((x+5) div 10) * 10;
                                 y := ((y+5) div 10) * 10;
                                end;
 mouseX := x; mouseY := y;
 mouseEvent := meMove;
 mouseproc;
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mouseEvent := meUp;
 mouseproc;
end;

//------------------ paint ---------------

procedure TForm1.FormPaint(Sender: TObject);
//paint edge around all paintboxes
var i : byte;
begin
 for i:= 0 to componentcount-1 do
  if components[i] is Tpaintbox then frame(TControl(components[i]));//misc_unit
end;

procedure TForm1.mainbtnBtnPaint(sender: TObject; BtnNr: Byte;
  status: TBtnStatus);
const maintext : array[0..9] of string =
                 ('clear','cliprect','dot','line','ellipse','arc',
                  'rectangle','floodfil','polygon','picture');
var r : Trect;
    x,y : word;
begin
 with mainbtn do with canvas do
  begin
   r := getBtnrect(BtnNr);
   x := r.left + ((btnwidth-textwidth(maintext[btnnr])) shr 1);
   y := r.top + ((btnheight-textheight(maintext[btnnr])) shr 1);
   textout(x,y,maintext[btnNr]);
  end;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.Canvas.draw(0,0,map2);
end;

procedure TForm1.lineboxPaint(Sender: TObject);
begin
 linebox.canvas.draw(0,0,linemap);
end;

procedure TForm1.brushboxPaint(Sender: TObject);
begin
 with brushbox do with canvas do
  begin
   brush.Color := brushcolor;
   fillrect(rect(0,0,width,height));
  end;
end;

procedure TForm1.fillboxPaint(Sender: TObject);
begin
 fillbox.Canvas.draw(0,0,fillmap);
end;

//------------ property selection ---------------

procedure TForm1.penwidthUDClick(Sender: TObject; Button: TUDBtnType);
begin
 penwidth := penwidthUD.Position;
 showlinestyle;
end;

procedure TForm1.arrowstyleUDClick(Sender: TObject; Button: TUDBtnType);
begin
 arrowcode := (arrowcode and $f0) or arrowstyleUD.position;
 showlinestyle;
end;

procedure TForm1.arr1checkClick(Sender: TObject);
begin
 if arr1check.checked then arrowcode := arrowcode or $40
 else arrowcode := arrowcode and $bf;
 if arr2check.checked then arrowcode := arrowcode or $80
 else arrowcode := arrowcode and $7f;
 showlinestyle;
end;

procedure TForm1.fillstyleUDClick(Sender: TObject; Button: TUDBtnType);
begin
 fillstyle := fillstyleUD.position;
 showfillstyle;
end;

procedure TForm1.fillpatgroupClick(Sender: TObject);
begin
 case fillpatgroup.itemindex of
  0 : fillsize := fms8;
  1 : fillsize := fms24;
 end;
 showfillstyle; 
end;

procedure TForm1.penstyleUDClick(Sender: TObject; Button: TUDBtnType);
begin
 linestyle := penstyleUD.position;
 showlinestyle;
end;

procedure TForm1.penlevelUDClick(Sender: TObject; Button: TUDBtnType);
begin
 penlevel := penlevelUD.position;
end;

procedure TForm1.brushlevelUDClick(Sender: TObject; Button: TUDBtnType);
begin
 brushlevel := brushlevelUD.position;
end;

procedure TForm1.radiusUDClick(Sender: TObject; Button: TUDBtnType);
begin
 radius := radiusUD.position;
end;

procedure TForm1.stretchgroupClick(Sender: TObject);
begin
 if stretchgroup.itemindex = 0 then stretchmode := smFullSource
 else stretchmode := smFulldest;
end;

procedure TForm1.brushcheckClick(Sender: TObject);
begin
 brushflag := brushcheck.checked;
 showlinestyle;
end;


//---------- create ------------

procedure TForm1.FormCreate(Sender: TObject);
begin
 with paintbox1 do fullmaprect := rect(0,0,width,height);
 paintBox1.canvas.copymode := cmSRCcopy;
 map1 := TXbitmap.create;
 with map1 do
  begin
   width := paintbox1.width;
   height := paintbox1.height;
   canvas.copymode := cmSRCcopy;
   Xcliprect := fullmaprect;
   maprect := fullmaprect;
  end;
 map2 := TXbitmap.create;
 with map2 do
  begin
   width := paintbox1.width;
   height := paintbox1.height;
   Canvas.copymode := cmSRCcopy;
   Xcliprect := fullmaprect;
  end;
 linemap := TXbitmap.create;
 with linemap do
  begin
   width := linebox.width;
   height := linebox.height;
   xcliprect := rect(0,0,width,height);
  end;
 fillmap := TXbitmap.create;
 with fillmap do
  begin
   width := fillbox.width;
   height := fillbox.height;
   xcliprect := rect(0,0,width,height);
  end;
 clearmaps;  //clear, paint grid, copy to paintbox1
 with mainbtn.canvas.Font do
  begin
   Size := 10; style := [fsBold];
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 map1.free;
 map2.free;
 linemap.free;
 fillmap.free;
 if assigned(bm) then begin
                       bm.free;
                       bm := nil;
                      end; 
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
 showlinestyle;
 showfillstyle;
end;

//---------support

procedure showlinestyle;
//paint linebox to show linestyle
var y : integer;
begin
 with linemap do with canvas do
  begin
   brush.color := $ffffff;
   fillrect(rect(0,0,width,height));
   y := height shr 1;
   XpenColor := pencolor;
   Xbrushcolor := brushcolor;
   Xbrushlevel := brushlevel;
   Xpenlevel := penlevel;
   Xlinestyle := linestyle;
   Xpenwidth := penwidth;
   Xarrowcode := arrowcode;
   Xusebrush := brushflag;
   Xline(20,y,width-20,y);
  end;
 form1.linebox.invalidate;
end;

procedure showfillstyle;
begin
 with fillmap do with canvas do
  begin
   fillrect(rect(0,0,width,height));
   XfillStyle := fillstyle;
   Xfillmapsize := fillsize;
   Xbrushlevel := brushlevel;
   Xbrushcolor := brushcolor;
   Xfloodfill(10,10);
  end;
 form1.fillbox.invalidate;
end;
 
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
//save map1 to file
begin
 if (shift = [ssCtrl]) and (Key = ord('P')) then
  if savedialog1.execute then
   with savedialog1 do
    map1.savetofile(filename);
end;

procedure TForm1.dav7ColorPicker1Select(sender: TObject; color: Integer);
begin
 pencolor := color;
 showlinestyle;
end;

procedure TForm1.dav7ColorPicker2Select(sender: TObject; color: Integer);
begin
 brushcolor := color;
 showFillStyle;
 showlinestyle;
 brushbox.invalidate;
end;

end.
